/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package odat_servidor;

import Controllers.Database;
import Controllers.centers;
import java.awt.Color;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Random;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.sound.midi.ControllerEventListener;
import javax.swing.JOptionPane;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

/**
 *
 * @author Lucia Tortosa
 */
public class ODAT_Servidor {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            new Server();
        } catch (IOException ex) {
            Logger.getLogger(ODAT_Servidor.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}

class Server {

    private static int maxClientsCount = 10;
    private static final Lectura[] cliente = new Lectura[maxClientsCount];
    static ServerSocket server;
    static ServerSocket servsock;
    String cad;
    String cadena = "CHAT";
    public static String linea = "";

    public Server() throws IOException {
        server = new ServerSocket(9999);
        servsock = new ServerSocket(8000);
        SpinnerNumberModel sModel = new SpinnerNumberModel(10, 0, 30, 1);
        JSpinner spinner = new JSpinner(sModel);
        int con = 10;
        con = JOptionPane.showOptionDialog(null, spinner, "Introduce numero maximo de conexiones", JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, null);
        if (con == JOptionPane.OK_OPTION) {
            maxClientsCount = (int) spinner.getValue();
            System.out.println("Se han asignado " + maxClientsCount + " conexiones como maximo.");
        } else if (con == JOptionPane.CANCEL_OPTION) {
            maxClientsCount = 10;
            System.out.println("Numero máximo de conexiones por defecto: 10");
        }
        while (true) {
            Socket c = null;
            c = server.accept();

            if (c != null) {
                int i = 0;
                for (i = 0; i < maxClientsCount; i++) {
                    if (cliente[i] == null) {
                        (cliente[i] = new Lectura(c, cliente)).start();
                        break;
                    }
                }
                if (i == maxClientsCount) {
                    System.out.println("Otros clientes desean conectarse... Hay que abrir mas conexiones a la proxima");
                }
                OutputStream os = c.getOutputStream();
                DataOutputStream dos = new DataOutputStream(os);
            } else {
                System.out.println("Socket cliente no creado");
            }
        }
    }
}

class Lectura extends Thread {

    private boolean cerrar = false;
    private int maxClientsCount;
    String cadena = null;
    String nicks = "";
    String privat = "";
    int color = 0;
    private String nick = null;
    private Socket c;
    private final Lectura[] cliente;
    private DataOutputStream dos = null;

    public Lectura(Socket c, Lectura[] cliente) {
        this.c = c;
        this.cliente = cliente;
        maxClientsCount = cliente.length;
    }

    public void cerrar() {
        cerrar = true;
    }

    public void run() {
        int maxClientsCount = this.maxClientsCount;
        Lectura[] cliente = this.cliente;
        try {
            InputStream is = c.getInputStream();
            OutputStream os = c.getOutputStream();
            DataInputStream dis = new DataInputStream(is);
            dos = new DataOutputStream(os);

            boolean login = false;
            while (login == false) {
                cadena = dis.readUTF();
                if (cadena.contains("login")) {
                    String[] data = cadena.split("\t");

                    Controllers.login controller = new Controllers.login();
                    int center_id = controller.select(data[1], data[2]);
                    if (controller.select(data[1], data[2]) != 0) {
                        dos.writeUTF(center_id + "");
                        login = true;
                    } else {
                        System.out.println("Error de conexion");
                        dos.writeUTF("0");
                    }

                } else if (cadena.contains("newUser")) {
                    Controllers.users users = new Controllers.users();
                    int id = users.insert(cadena);
                    dos.writeUTF(id + "");
                    System.out.println("id: " + id);
                }
            }

            Database db = new Database();
            System.out.println("Ha pasado fase login.");

            while (true) {
                cadena = dis.readUTF();
                System.out.println(cadena);
                
                
                if (cadena.startsWith("/exit")) {
                    break;
                } else {
                    int id = db.getId(cadena);
                    dos.writeUTF(id + "");
                }
//                synchronized (cliente) {
//                    Database db = new Database();
//
//                    String key = db.Database(cadena) + "";
//
//                    for (int i = 0; i < maxClientsCount; i++) {
//                        if (cliente[i] == this) {
//                            cliente[i].dos.writeUTF(key);
//                        }
//                    }
//                }
//            }
//            synchronized (cliente) {
//                for (int i = 0; i < maxClientsCount; i++) {
//                    if (cliente[i] == this) {
//                        cliente[i] = null;
//                        System.out.println("Se ha liberado el recurso del cliente.");
//                    }
//                }
            }

            is.close();
            os.close();
            c.close();
            System.out.println("Se han cerrado correctamente el hilo y conexiones del cliente.");

        } catch (IOException ex) {
            Logger.getLogger(Server.class
                    .getName()).log(Level.SEVERE, null, ex);

        }
    }

}
